local modname = minetest.get_current_modname()
local modpath = minetest.get_modpath(modname)
local S = minetest.get_translator(modname)

--Item Crafting Recipes

--rose gold nuggets
minetest.register_craft({
    output = "mcl_rose_gold:rose_gold_nugget 9",
    recipe = {
        {"mcl_rose_gold:rose_gold_ingot"},
    },
})
--rose gold ingot
minetest.register_craft({
	type = "shapeless",
	output = "mcl_rose_gold:raw_rose_gold_ore 2",
	recipe = {
		 "mcl_copper:raw_copper", "mcl_raw_ores:raw_gold","mcl_mobitems:blaze_powder",
		 "mcl_raw_ores:raw_gold", "mcl_nether:quartz",
	},
})

--rose gold ingot (9 nuggets)
minetest.register_craft({
	output = "mcl_rose_gold:rose_gold_ingot",
	recipe = {
		{"mcl_rose_gold:rose_gold_nugget", "mcl_rose_gold:rose_gold_nugget", "mcl_rose_gold:rose_gold_nugget"},
		{"mcl_rose_gold:rose_gold_nugget", "mcl_rose_gold:rose_gold_nugget", "mcl_rose_gold:rose_gold_nugget"},
		{"mcl_rose_gold:rose_gold_nugget", "mcl_rose_gold:rose_gold_nugget", "mcl_rose_gold:rose_gold_nugget"},
	},
})



--Node Crafting Recipes


-- Raw rose gold ore block
minetest.register_craft({
	output = "mcl_rose_gold:raw_rose_gold_ore_block",
	recipe = {
		{ "mcl_rose_gold:raw_rose_gold_ore", "mcl_rose_gold:raw_rose_gold_ore" },
		{ "mcl_rose_gold:raw_rose_gold_ore", "mcl_rose_gold:raw_rose_gold_ore" },
	},
})
-- uncrafting
minetest.register_craft({
	type = "shapeless",
	output = "mcl_rose_gold:raw_rose_gold_ore 4",
	recipe = {
		 "mcl_rose_gold:raw_rose_gold_ore_block",
	},
})

-- rose gold block
minetest.register_craft({
	output = "mcl_rose_gold:rose_gold_block",
	recipe = {
		{ "mcl_rose_gold:rose_gold_ingot", "mcl_rose_gold:rose_gold_ingot" },
		{ "mcl_rose_gold:rose_gold_ingot", "mcl_rose_gold:rose_gold_ingot" },
	},
})

-- uncrafting
minetest.register_craft({
	type = "shapeless",
	output = "mcl_rose_gold:rose_gold_ingot 4",
	recipe = {
		 "mcl_rose_gold:rose_gold_block",
	},
})



--Waxed rose gold block
minetest.register_craft({
	type = "shapeless",
	output = "mcl_rose_gold:waxed_rose_gold_block",
	recipe = {
		 "mcl_rose_gold:rose_gold_block", "mcl_honey:honeycomb",
	},
})

--exposed rose gold block
minetest.register_craft({
	type = "shapeless",
	output = "mcl_rose_gold:rose_gold_block_exposed",
	recipe = {
		 "mcl_rose_gold:rose_gold_block", "mcl_buckets:bucket_water",
	},
	replacements = {{"mcl_buckets:bucket_water", "mcl_buckets:bucket_empty"}},
})

-- rose gold lantern
minetest.register_craft({
	output = "mcl_lanterns:rose_gold_lantern_floor",
	recipe = {
		{"mcl_rose_gold:rose_gold_nugget", "mcl_rose_gold:rose_gold_nugget", "mcl_rose_gold:rose_gold_nugget"},
		{"mcl_rose_gold:rose_gold_nugget", "mcl_torches:torch"             , "mcl_rose_gold:rose_gold_nugget"},
		{"mcl_rose_gold:rose_gold_nugget", "mcl_rose_gold:rose_gold_nugget", "mcl_rose_gold:rose_gold_nugget"},
	},
})
--rose gold chain
minetest.register_craft({
	output = "mcl_rose_gold:rose_gold_chain",
	recipe = {
		{"mcl_rose_gold:rose_gold_nugget"},
		{"mcl_rose_gold:rose_gold_ingot"},
		{"mcl_rose_gold:rose_gold_nugget"},
	},
})


--Tool crafting recipes


--rose gold pick
minetest.register_craft({
	output = "mcl_rose_gold:rose_gold_pick",
	recipe = {
		{"mcl_rose_gold:rose_gold_ingot", "mcl_rose_gold:rose_gold_ingot", "mcl_rose_gold:rose_gold_ingot"},
		{"", "mcl_core:stick", ""},
		{"", "mcl_core:stick", ""},
	}
})
--rose gold axe
minetest.register_craft({
	output = "mcl_rose_gold:rose_gold_axe",
	recipe = {
		{"mcl_rose_gold:rose_gold_ingot", "mcl_rose_gold:rose_gold_ingot"},
		{"mcl_rose_gold:rose_gold_ingot", "mcl_core:stick"},
		{"", "mcl_core:stick"},
	}
})
--rose gold shovel
minetest.register_craft({
	output = "mcl_rose_gold:rose_gold_shovel",
	recipe = {
		{"mcl_rose_gold:rose_gold_ingot"},
		{"mcl_core:stick"},
		{"mcl_core:stick"},
	}
})
--rose gold sword
minetest.register_craft({
	output = "mcl_rose_gold:rose_gold_sword",
	recipe = {
		{"mcl_rose_gold:rose_gold_ingot"},
		{"mcl_rose_gold:rose_gold_ingot"},
		{"mcl_core:stick"},
	}
})
--rose gold shears
minetest.register_craft({
	output = "mcl_rose_gold:rose_gold_shears",
	recipe = {
		{ "", "mcl_rose_gold:rose_gold_ingot" },
		{ "mcl_rose_gold:rose_gold_ingot", "" },
	}
})

minetest.register_craft({
	output = "mcl_rose_gold:rose_gold_shears",
	recipe = {
		{ "mcl_rose_gold:rose_gold_ingot", "" },
		{ "", "mcl_rose_gold:rose_gold_ingot" },
	}
})
--rose gold hoe
minetest.register_craft({
	output = "mcl_rose_gold:rose_gold_hoe",
	recipe = {
		{"mcl_rose_gold:rose_gold_ingot", "mcl_rose_gold:rose_gold_ingot"},
		{"", "mcl_core:stick"},
		{"", "mcl_core:stick"},
	}
})

--Furnace Cooking Recipes

	minetest.register_craft({
		type = "cooking",
		output = "mcl_rose_gold:rose_gold_ingot",
		recipe = "mcl_rose_gold:raw_rose_gold_ore",
		cooktime = 10,
	})

	minetest.register_craft({
		type = "cooking",
		output = "mcl_rose_gold:rose_gold_block",
		recipe = "mcl_rose_gold:raw_rose_gold_ore_block",
		cooktime = 90,
	})
